// @ts-nocheck
/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * The version of the OpenAPI document: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { IoArgoprojEventsV1alpha1Backoff } from './ioArgoprojEventsV1alpha1Backoff';
import { IoArgoprojEventsV1alpha1TLSConfig } from './ioArgoprojEventsV1alpha1TLSConfig';
import { IoArgoprojEventsV1alpha1TriggerParameter } from './ioArgoprojEventsV1alpha1TriggerParameter';
import { IoK8sApiCoreV1SecretKeySelector } from './ioK8sApiCoreV1SecretKeySelector';

/**
* PulsarTrigger refers to the specification of the Pulsar trigger.
*/
export class IoArgoprojEventsV1alpha1PulsarTrigger {
    'authTokenSecret'?: IoK8sApiCoreV1SecretKeySelector;
    'connectionBackoff'?: IoArgoprojEventsV1alpha1Backoff;
    /**
    * Parameters is the list of parameters that is applied to resolved Kafka trigger object.
    */
    'parameters'?: Array<IoArgoprojEventsV1alpha1TriggerParameter>;
    /**
    * Payload is the list of key-value extracted from an event payload to construct the request payload.
    */
    'payload'?: Array<IoArgoprojEventsV1alpha1TriggerParameter>;
    'tls'?: IoArgoprojEventsV1alpha1TLSConfig;
    'tlsAllowInsecureConnection'?: boolean;
    'tlsTrustCertsSecret'?: IoK8sApiCoreV1SecretKeySelector;
    'tlsValidateHostname'?: boolean;
    'topic'?: string;
    'url'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "authTokenSecret",
            "baseName": "authTokenSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector"
        },
        {
            "name": "connectionBackoff",
            "baseName": "connectionBackoff",
            "type": "IoArgoprojEventsV1alpha1Backoff"
        },
        {
            "name": "parameters",
            "baseName": "parameters",
            "type": "Array<IoArgoprojEventsV1alpha1TriggerParameter>"
        },
        {
            "name": "payload",
            "baseName": "payload",
            "type": "Array<IoArgoprojEventsV1alpha1TriggerParameter>"
        },
        {
            "name": "tls",
            "baseName": "tls",
            "type": "IoArgoprojEventsV1alpha1TLSConfig"
        },
        {
            "name": "tlsAllowInsecureConnection",
            "baseName": "tlsAllowInsecureConnection",
            "type": "boolean"
        },
        {
            "name": "tlsTrustCertsSecret",
            "baseName": "tlsTrustCertsSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector"
        },
        {
            "name": "tlsValidateHostname",
            "baseName": "tlsValidateHostname",
            "type": "boolean"
        },
        {
            "name": "topic",
            "baseName": "topic",
            "type": "string"
        },
        {
            "name": "url",
            "baseName": "url",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojEventsV1alpha1PulsarTrigger.attributeTypeMap;
    }
}

