// @ts-nocheck
/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * The version of the OpenAPI document: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { IoArgoprojWorkflowV1alpha1ArchiveStrategy } from './ioArgoprojWorkflowV1alpha1ArchiveStrategy';
import { IoArgoprojWorkflowV1alpha1ArtifactGC } from './ioArgoprojWorkflowV1alpha1ArtifactGC';
import { IoArgoprojWorkflowV1alpha1ArtifactoryArtifact } from './ioArgoprojWorkflowV1alpha1ArtifactoryArtifact';
import { IoArgoprojWorkflowV1alpha1AzureArtifact } from './ioArgoprojWorkflowV1alpha1AzureArtifact';
import { IoArgoprojWorkflowV1alpha1GCSArtifact } from './ioArgoprojWorkflowV1alpha1GCSArtifact';
import { IoArgoprojWorkflowV1alpha1GitArtifact } from './ioArgoprojWorkflowV1alpha1GitArtifact';
import { IoArgoprojWorkflowV1alpha1HDFSArtifact } from './ioArgoprojWorkflowV1alpha1HDFSArtifact';
import { IoArgoprojWorkflowV1alpha1HTTPArtifact } from './ioArgoprojWorkflowV1alpha1HTTPArtifact';
import { IoArgoprojWorkflowV1alpha1OSSArtifact } from './ioArgoprojWorkflowV1alpha1OSSArtifact';
import { IoArgoprojWorkflowV1alpha1RawArtifact } from './ioArgoprojWorkflowV1alpha1RawArtifact';
import { IoArgoprojWorkflowV1alpha1S3Artifact } from './ioArgoprojWorkflowV1alpha1S3Artifact';

/**
* Artifact indicates an artifact to place at a specified path
*/
export class IoArgoprojWorkflowV1alpha1Artifact {
    'archive'?: IoArgoprojWorkflowV1alpha1ArchiveStrategy;
    /**
    * ArchiveLogs indicates if the container logs should be archived
    */
    'archiveLogs'?: boolean;
    'artifactGC'?: IoArgoprojWorkflowV1alpha1ArtifactGC;
    'artifactory'?: IoArgoprojWorkflowV1alpha1ArtifactoryArtifact;
    'azure'?: IoArgoprojWorkflowV1alpha1AzureArtifact;
    /**
    * Has this been deleted?
    */
    'deleted'?: boolean;
    /**
    * From allows an artifact to reference an artifact from a previous step
    */
    'from'?: string;
    /**
    * FromExpression, if defined, is evaluated to specify the value for the artifact
    */
    'fromExpression'?: string;
    'gcs'?: IoArgoprojWorkflowV1alpha1GCSArtifact;
    'git'?: IoArgoprojWorkflowV1alpha1GitArtifact;
    /**
    * GlobalName exports an output artifact to the global scope, making it available as \'{{io.argoproj.workflow.v1alpha1.outputs.artifacts.XXXX}} and in workflow.status.outputs.artifacts
    */
    'globalName'?: string;
    'hdfs'?: IoArgoprojWorkflowV1alpha1HDFSArtifact;
    'http'?: IoArgoprojWorkflowV1alpha1HTTPArtifact;
    /**
    * mode bits to use on this file, must be a value between 0 and 0777 set when loading input artifacts.
    */
    'mode'?: number;
    /**
    * name of the artifact. must be unique within a template\'s inputs/outputs.
    */
    'name': string;
    /**
    * Make Artifacts optional, if Artifacts doesn\'t generate or exist
    */
    'optional'?: boolean;
    'oss'?: IoArgoprojWorkflowV1alpha1OSSArtifact;
    /**
    * Path is the container path to the artifact
    */
    'path'?: string;
    'raw'?: IoArgoprojWorkflowV1alpha1RawArtifact;
    /**
    * If mode is set, apply the permission recursively into the artifact if it is a folder
    */
    'recurseMode'?: boolean;
    's3'?: IoArgoprojWorkflowV1alpha1S3Artifact;
    /**
    * SubPath allows an artifact to be sourced from a subpath within the specified source
    */
    'subPath'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "archive",
            "baseName": "archive",
            "type": "IoArgoprojWorkflowV1alpha1ArchiveStrategy"
        },
        {
            "name": "archiveLogs",
            "baseName": "archiveLogs",
            "type": "boolean"
        },
        {
            "name": "artifactGC",
            "baseName": "artifactGC",
            "type": "IoArgoprojWorkflowV1alpha1ArtifactGC"
        },
        {
            "name": "artifactory",
            "baseName": "artifactory",
            "type": "IoArgoprojWorkflowV1alpha1ArtifactoryArtifact"
        },
        {
            "name": "azure",
            "baseName": "azure",
            "type": "IoArgoprojWorkflowV1alpha1AzureArtifact"
        },
        {
            "name": "deleted",
            "baseName": "deleted",
            "type": "boolean"
        },
        {
            "name": "from",
            "baseName": "from",
            "type": "string"
        },
        {
            "name": "fromExpression",
            "baseName": "fromExpression",
            "type": "string"
        },
        {
            "name": "gcs",
            "baseName": "gcs",
            "type": "IoArgoprojWorkflowV1alpha1GCSArtifact"
        },
        {
            "name": "git",
            "baseName": "git",
            "type": "IoArgoprojWorkflowV1alpha1GitArtifact"
        },
        {
            "name": "globalName",
            "baseName": "globalName",
            "type": "string"
        },
        {
            "name": "hdfs",
            "baseName": "hdfs",
            "type": "IoArgoprojWorkflowV1alpha1HDFSArtifact"
        },
        {
            "name": "http",
            "baseName": "http",
            "type": "IoArgoprojWorkflowV1alpha1HTTPArtifact"
        },
        {
            "name": "mode",
            "baseName": "mode",
            "type": "number"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "optional",
            "baseName": "optional",
            "type": "boolean"
        },
        {
            "name": "oss",
            "baseName": "oss",
            "type": "IoArgoprojWorkflowV1alpha1OSSArtifact"
        },
        {
            "name": "path",
            "baseName": "path",
            "type": "string"
        },
        {
            "name": "raw",
            "baseName": "raw",
            "type": "IoArgoprojWorkflowV1alpha1RawArtifact"
        },
        {
            "name": "recurseMode",
            "baseName": "recurseMode",
            "type": "boolean"
        },
        {
            "name": "s3",
            "baseName": "s3",
            "type": "IoArgoprojWorkflowV1alpha1S3Artifact"
        },
        {
            "name": "subPath",
            "baseName": "subPath",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1Artifact.attributeTypeMap;
    }
}

