// @ts-nocheck
/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * The version of the OpenAPI document: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { IoK8sApiCoreV1SecretKeySelector } from './ioK8sApiCoreV1SecretKeySelector';

/**
* GitArtifact is the location of an git artifact
*/
export class IoArgoprojWorkflowV1alpha1GitArtifact {
    /**
    * Branch is the branch to fetch when `SingleBranch` is enabled
    */
    'branch'?: string;
    /**
    * Depth specifies clones/fetches should be shallow and include the given number of commits from the branch tip
    */
    'depth'?: number;
    /**
    * DisableSubmodules disables submodules during git clone
    */
    'disableSubmodules'?: boolean;
    /**
    * Fetch specifies a number of refs that should be fetched before checkout
    */
    'fetch'?: Array<string>;
    /**
    * InsecureIgnoreHostKey disables SSH strict host key checking during git clone
    */
    'insecureIgnoreHostKey'?: boolean;
    'passwordSecret'?: IoK8sApiCoreV1SecretKeySelector;
    /**
    * Repo is the git repository
    */
    'repo': string;
    /**
    * Revision is the git commit, tag, branch to checkout
    */
    'revision'?: string;
    /**
    * SingleBranch enables single branch clone, using the `branch` parameter
    */
    'singleBranch'?: boolean;
    'sshPrivateKeySecret'?: IoK8sApiCoreV1SecretKeySelector;
    'usernameSecret'?: IoK8sApiCoreV1SecretKeySelector;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "branch",
            "baseName": "branch",
            "type": "string"
        },
        {
            "name": "depth",
            "baseName": "depth",
            "type": "number"
        },
        {
            "name": "disableSubmodules",
            "baseName": "disableSubmodules",
            "type": "boolean"
        },
        {
            "name": "fetch",
            "baseName": "fetch",
            "type": "Array<string>"
        },
        {
            "name": "insecureIgnoreHostKey",
            "baseName": "insecureIgnoreHostKey",
            "type": "boolean"
        },
        {
            "name": "passwordSecret",
            "baseName": "passwordSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector"
        },
        {
            "name": "repo",
            "baseName": "repo",
            "type": "string"
        },
        {
            "name": "revision",
            "baseName": "revision",
            "type": "string"
        },
        {
            "name": "singleBranch",
            "baseName": "singleBranch",
            "type": "boolean"
        },
        {
            "name": "sshPrivateKeySecret",
            "baseName": "sshPrivateKeySecret",
            "type": "IoK8sApiCoreV1SecretKeySelector"
        },
        {
            "name": "usernameSecret",
            "baseName": "usernameSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector"
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1GitArtifact.attributeTypeMap;
    }
}

