// @ts-nocheck
/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * The version of the OpenAPI document: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { IoArgoprojWorkflowV1alpha1ManifestFrom } from './ioArgoprojWorkflowV1alpha1ManifestFrom';

/**
* ResourceTemplate is a template subtype to manipulate kubernetes resources
*/
export class IoArgoprojWorkflowV1alpha1ResourceTemplate {
    /**
    * Action is the action to perform to the resource. Must be one of: get, create, apply, delete, replace, patch
    */
    'action': string;
    /**
    * FailureCondition is a label selector expression which describes the conditions of the k8s resource in which the step was considered failed
    */
    'failureCondition'?: string;
    /**
    * Flags is a set of additional options passed to kubectl before submitting a resource I.e. to disable resource validation: flags: [  \"--validate=false\"  # disable resource validation ]
    */
    'flags'?: Array<string>;
    /**
    * Manifest contains the kubernetes manifest
    */
    'manifest'?: string;
    'manifestFrom'?: IoArgoprojWorkflowV1alpha1ManifestFrom;
    /**
    * MergeStrategy is the strategy used to merge a patch. It defaults to \"strategic\" Must be one of: strategic, merge, json
    */
    'mergeStrategy'?: string;
    /**
    * SetOwnerReference sets the reference to the workflow on the OwnerReference of generated resource.
    */
    'setOwnerReference'?: boolean;
    /**
    * SuccessCondition is a label selector expression which describes the conditions of the k8s resource in which it is acceptable to proceed to the following step
    */
    'successCondition'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "action",
            "baseName": "action",
            "type": "string"
        },
        {
            "name": "failureCondition",
            "baseName": "failureCondition",
            "type": "string"
        },
        {
            "name": "flags",
            "baseName": "flags",
            "type": "Array<string>"
        },
        {
            "name": "manifest",
            "baseName": "manifest",
            "type": "string"
        },
        {
            "name": "manifestFrom",
            "baseName": "manifestFrom",
            "type": "IoArgoprojWorkflowV1alpha1ManifestFrom"
        },
        {
            "name": "mergeStrategy",
            "baseName": "mergeStrategy",
            "type": "string"
        },
        {
            "name": "setOwnerReference",
            "baseName": "setOwnerReference",
            "type": "boolean"
        },
        {
            "name": "successCondition",
            "baseName": "successCondition",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1ResourceTemplate.attributeTypeMap;
    }
}

